/*****************************
File:       RemoteSFInt32.CPP
Language:   C++ (header)
Project:    H3DNetworkingUtils
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is H3DNetworkingUtils v1.0.

The Initial Developer of the Original Code is CSIRO.
Portions created by the Initial Developer are Copyright (C) 1009 CSIRO. All Rights Reserved.
Contributor(s):
    Chris Gunn  <Chris.Gunn@csiro.au> <ChrisJGunn@gmail.com>
***************************/
#include "H3DNetworkingUtils/RemoteSFInt32.h"
#include "H3DNetworkingUtils/RemoteConnection.h"

#ifdef _WIN32
#include "RemoteSF.cpp"
#endif

using namespace H3D;
using namespace H3DNetworkingUtils;

H3DNodeDatabase RemoteSFInt32::database(   
  "RemoteSFInt32", 
  &(newInstance<RemoteSFInt32>),
  typeid(RemoteSFInt32),
  &RemoteSF<SFInt32>::database);

// toBeSent and received are really fields of the parent class but because of
// a bug in Win32 template instantiation they must be included here instead.
namespace RemoteSFInt32Internals {   
  FIELDDB_ELEMENT( RemoteSFInt32, toBeSent, INPUT_ONLY );
  FIELDDB_ELEMENT( RemoteSFInt32, received, OUTPUT_ONLY );
}

// ----------------------------------------------------------------------------
RemoteSFInt32::RemoteSFInt32() :
RemoteSF<SFInt32>(H3D::X3DTypes::SFINT32) {

  type_name = "RemoteSFInt32";
  database.initFields( this );

  received->initialiseValue(0);

  // test code
  SFInt32 * tmpP = dynamic_cast<SFInt32*>(received.get());
}

// ----------------------------------------------------------------------------
void RemoteSFInt32::readValue() {
  int val;
  val = readInt32();
  if (!conP->closeRequested()) {
    received->setValue(val, id);
  }
}

